/*LOG_DFE_PARAMCMPPROD responsvel por gravar as informaes
  na tabela LOGOPERA a partir dos registros que forem includos,
  excludos e alterados na tabela PARAMCMPPROD
  Criao: 20/03/2012
  Lucas Primo

  RAISERROR(@V_ID_COMANDO, 16,1);
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_DFE_PARAMCMPPROD'
             AND TYPE   = 'TR'
             AND U.UID  = O.UID
             AND U.NAME = USER)
DROP TRIGGER LOG_DFE_PARAMCMPPROD
GO

CREATE TRIGGER LOG_DFE_PARAMCMPPROD
ON PARAMCMPPROD
FOR INSERT, UPDATE, DELETE
AS
  DECLARE  @V_CDFILLOGOPER  VARCHAR(4);
  DECLARE  @V_USUARIO       VARCHAR(40);
  DECLARE  @V_TIPO	    VARCHAR(1);
  DECLARE  @V_ITPESQ  	    VARCHAR(40);
  DECLARE  @V_DESC	    VARCHAR(300);
  DECLARE  @V_DTOPER	    DATETIME;
  DECLARE  @V_DSREMOTEADDR  VARCHAR(15);
  DECLARE  @V_DSREMOTEHOST  VARCHAR(15);
  DECLARE  @V_DSSERVERRDM   VARCHAR(20);
  DECLARE  @V_DSSERVMETHOD  VARCHAR(30);
  DECLARE  @V_DSREMOTEOPER  VARCHAR(12);

/*VARIVEIS DO CURSOR C_CURSOR*/

  DECLARE  @V_ID_COMANDO       VARCHAR(1);
  DECLARE  @V_CDFILIAL_OLD     VARCHAR(4);
  DECLARE  @V_CDPRODUTO_OLD    VARCHAR(10);
  DECLARE  @V_IDBLOQNFSAF_OLD  VARCHAR(1);

  DECLARE  @V_CDFILIAL_NEW     VARCHAR(4);
  DECLARE  @V_CDPRODUTO_NEW    VARCHAR(10);
  DECLARE  @V_IDBLOQNFSAF_NEW  VARCHAR(1);
  DECLARE  @V_CDARVPROD        VARCHAR(20);
BEGIN
   SET @V_TIPO = '0';
   SET @V_DESC = '';
   SET @V_CDFILLOGOPER = '';
   SET @V_CDARVPROD    = '';

   EXEC WEBTUNNING @P_DSREMOTEADDR = @V_DSREMOTEADDR OUTPUT,
                   @P_DSREMOTEHOST = @V_DSREMOTEHOST OUTPUT,
                   @P_DSSERVERRDM  = @V_DSSERVERRDM OUTPUT,
                   @P_DSSERVMETHOD = @V_DSSERVMETHOD OUTPUT,
                   @P_DSREMOTEOPER = @V_DSREMOTEOPER OUTPUT;

   EXEC NMUSUARIO @P_NMUSUARIO = @V_USUARIO OUTPUT;

   SET @V_USUARIO = ISNULL(@V_USUARIO, '');

   DECLARE C_CURSOR CURSOR FOR

   SELECT
     'D' IDCOMANDO,
         NULL,
         NULL,
         NULL,
         
         CDFILIAL,
         CDPRODUTO,
         IDBLOQNFSAF
   FROM
     DELETED
   WHERE
     0 = (SELECT COUNT(1) FROM INSERTED)
     --CDFILIAL+CDPRODUTO NOT IN (SELECT CDFILIAL+CDPRODUTO FROM INSERTED)

   UNION ALL

   SELECT
     'U' IDCOMANDO,
      INSERTED.CDFILIAL,
      INSERTED.CDPRODUTO,
      INSERTED.IDBLOQNFSAF,

      DELETED.CDFILIAL,
      DELETED.CDPRODUTO,
      DELETED.IDBLOQNFSAF
     FROM
      INSERTED,
      DELETED

   UNION ALL

   SELECT
      'I' IDCOMANDO,
      CDFILIAL,
      CDPRODUTO,
      IDBLOQNFSAF,

      NULL,
      NULL,
      NULL
   FROM
      INSERTED
   WHERE
      --CDFILIAL+CDPRODUTO NOT IN (SELECT CDFILIAL+CDPRODUTO FROM DELETED);
      0 = (SELECT COUNT(1) FROM DELETED);
   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_CDFILIAL_NEW,
                                 @V_CDPRODUTO_NEW,
                                 @V_IDBLOQNFSAF_NEW,
                                 @V_CDFILIAL_OLD,
                                 @V_CDPRODUTO_OLD,
                                 @V_IDBLOQNFSAF_OLD;


   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF NOT (@V_USUARIO IS NULL) BEGIN

         IF @V_ID_COMANDO = 'D' BEGIN

            IF @V_CDFILIAL_OLD <> ' ' BEGIN
               SET @V_DESC = @V_DESC + ' Filial=' + @V_CDFILIAL_OLD;
            END;

            IF @V_CDPRODUTO_OLD <> ' '  BEGIN
               SELECT @V_CDARVPROD = CDARVPROD
                 FROM PRODUTO
                WHERE CDPRODUTO = @V_CDPRODUTO_OLD
               SET @V_DESC = @V_DESC + ' Prod=' + @V_CDARVPROD;
            END;

            IF @V_IDBLOQNFSAF_OLD <> ' ' BEGIN
               SET @V_DESC = @V_DESC + ' Bloq=' + CONVERT(VARCHAR,@V_IDBLOQNFSAF_OLD);
            END;

            SET @V_TIPO   = '3';
            SET @V_ITPESQ = @V_CDFILIAL_OLD + @V_CDARVPROD;
            SET @V_CDFILLOGOPER = @V_CDFILIAL_OLD;
         END;
         IF @V_ID_COMANDO = 'U' /*UPDATING*/ BEGIN

            IF (@V_CDFILIAL_OLD)       <> (@V_CDFILIAL_NEW)    OR
               (@V_CDPRODUTO_OLD)      <> (@V_CDPRODUTO_NEW)   OR
               (@V_IDBLOQNFSAF_OLD)    <> (@V_IDBLOQNFSAF_NEW) BEGIN

               IF (@V_CDFILIAL_NEW IS NOT NULL) BEGIN
                  SET @V_DESC = @V_DESC + ' Filial=' + @V_CDFILIAL_NEW;
               END;

               IF (@V_CDPRODUTO_NEW IS NOT NULL) BEGIN
                  SELECT @V_CDARVPROD = CDARVPROD
                    FROM PRODUTO
                   WHERE CDPRODUTO = @V_CDPRODUTO_NEW

                  SET @V_DESC = @V_DESC + ' Prod=' + @V_CDARVPROD;
               END;

               IF (@V_IDBLOQNFSAF_NEW IS NOT NULL) BEGIN
                  SET @V_DESC = @V_DESC + ' Bloq=' + @V_IDBLOQNFSAF_NEW;
               END;

               SET @V_CDARVPROD = '';
               SELECT @V_CDARVPROD = CDARVPROD
                 FROM PRODUTO
                WHERE CDPRODUTO = @V_CDPRODUTO_OLD

               SET @V_TIPO   = '2';
               SET @V_ITPESQ = @V_CDFILIAL_OLD + @V_CDARVPROD;
               SET @V_CDFILLOGOPER = @V_CDFILIAL_OLD;
            END;
         END;

         IF @V_ID_COMANDO = 'I' BEGIN
            IF @V_CDFILIAL_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Filial=' + @V_CDFILIAL_NEW;
            END;

            IF @V_CDPRODUTO_NEW IS NOT NULL BEGIN
               SELECT @V_CDARVPROD = CDARVPROD
                 FROM PRODUTO
                WHERE CDPRODUTO = @V_CDPRODUTO_NEW

               SET @V_DESC = @V_DESC + ' Prod=' + @V_CDARVPROD;
            END;

            IF @V_IDBLOQNFSAF_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Bloq=' + @V_IDBLOQNFSAF_NEW;
            END;

            SET @V_TIPO   = '1';

            SET @V_ITPESQ = @V_CDFILIAL_NEW + @V_CDARVPROD;

            SET @V_CDFILLOGOPER = @V_CDFILIAL_NEW;
         END;

         IF @V_TIPO <> '0' BEGIN
            EXEC NMUSUARIO @V_USUARIO;
            IF NOT (@V_DESC IS NULL) BEGIN
               IF NOT (@V_USUARIO IS NULL) BEGIN
                  SET @V_DTOPER = GETDATE();

                  SET @V_DESC = SUBSTRING(@V_DESC, 1, 300);

                  INSERT INTO LOGOPERA
                     (NMTABELA,   DTOPERACAO, NMRESPOPER,
                      IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                      DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                      DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
                  VALUES
                     ('PARAMCMPPROD',  @V_DTOPER, @V_USUARIO,
                      @V_TIPO,    @V_ITPESQ, @V_DESC,
                      @V_DSSERVERRDM, @V_DSREMOTEADDR, @V_DSREMOTEHOST,
                      @V_DSSERVMETHOD, @V_DSREMOTEOPER, @V_CDFILLOGOPER);
               END;
            END;
         END;

         FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                       @V_CDFILIAL_OLD,
                                       @V_CDPRODUTO_OLD,
                                       @V_IDBLOQNFSAF_OLD,

                                       @V_CDFILIAL_NEW,
                                       @V_CDPRODUTO_NEW,
                                       @V_IDBLOQNFSAF_NEW;


      END;
   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;


END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_DFE_PARAMCMPPROD','5.40.000';
GO
